/*
 *  Copyright (c) 1994 Michael D. Bayne.
 *  All rights reserved.
 *
 *  Please see the documentation accompanying the distribution for distribution
 *  and disclaimer information.
 */

#include <exec/memory.h>
#include <dos/dostags.h>

#include <clib/exec_protos.h>
#include <clib/dos_protos.h>
#include <clib/alib_protos.h>

#include "Executor.h"
#include "//defs.h"
#include "/main.h"

struct ModulePrefs
{
	BYTE StartString[128];
	BYTE StopString[128];
};

extern struct ModulePrefs nP;

struct Screen *ModuleScreen( VOID )
{
	return 0L;
}

LONG Blank( VOID *Prefs )
{
	struct ModulePrefs *wP;
	BPTR InFile, OutFile;
	LONG RetVal;
	
	if( ExecutorWnd )
		wP = &nP;
	else
		wP = ( struct ModulePrefs * )Prefs;
	
	InFile = Open( "NIL:", MODE_OLDFILE );
	OutFile = Open( "NIL:", MODE_OLDFILE );
	SystemTags( wP->StartString, NP_Name, "!* StealthProcess *!",
			   SYS_Asynch, TRUE, SYS_Input, InFile, SYS_Output, OutFile,
			   TAG_END );

	do
	{
		Delay( 5 );
		RetVal = ContinueBlanking();
	}
	while( RetVal == OK );

	InFile = Open( "NIL:", MODE_OLDFILE );
	OutFile = Open( "NIL:", MODE_OLDFILE );
	SystemTags( wP->StopString, SYS_Asynch, TRUE, SYS_Input, InFile,
			   SYS_Output, OutFile, TAG_END );

	return RetVal;
}
