/*
 *  Source machine generated by GadToolsBox V2.0b
 *  which is (c) Copyright 1991-1993 Jaba Development
 *
 *  GUI Designed by : Michael D. Bayne
 */

#include <exec/types.h>
#include <intuition/intuition.h>
#include <intuition/classes.h>
#include <intuition/classusr.h>
#include <intuition/imageclass.h>
#include <intuition/gadgetclass.h>
#include <libraries/gadtools.h>
#include <graphics/displayinfo.h>
#include <graphics/gfxbase.h>
#include <clib/exec_protos.h>
#include <clib/intuition_protos.h>
#include <clib/gadtools_protos.h>
#include <clib/graphics_protos.h>
#include <clib/utility_protos.h>
#include <string.h>
#include <clib/diskfont_protos.h>

#include "Executor.h"

struct Screen         *Scr = NULL;
UBYTE                 *PubScreenName = NULL;
APTR                   VisualInfo = NULL;
struct Window         *ExecutorWnd = NULL;
struct Gadget         *ExecutorGList = NULL;
struct IntuiMessage    ExecutorMsg;
struct Gadget         *ExecutorGadgets[5];
UWORD                  ExecutorLeft = 0;
UWORD                  ExecutorTop = 12;
UWORD                  ExecutorWidth = 190;
UWORD                  ExecutorHeight = 59;
UBYTE                 *ExecutorWdt = (UBYTE *)"Executor Prefs";
struct TextAttr       *Font, Attr;
UWORD                  FontX, FontY;
UWORD                  OffX, OffY;
struct TextFont       *ExecutorFont = NULL;

UWORD ExecutorGTypes[] = {
	BUTTON_KIND,
	BUTTON_KIND,
	BUTTON_KIND,
	STRING_KIND,
	STRING_KIND
};

struct NewGadget ExecutorNGad[] = {
	4, 42, 58, 14, (UBYTE *)"_Save", NULL, GD_BT_SAVE, PLACETEXT_IN, NULL, (APTR)BT_SAVEClicked,
	128, 42, 58, 14, (UBYTE *)"_Cancel", NULL, GD_BT_CANCEL, PLACETEXT_IN, NULL, (APTR)BT_CANCELClicked,
	66, 42, 58, 14, (UBYTE *)"_Test", NULL, GD_BT_TEST, PLACETEXT_IN, NULL, (APTR)BT_TESTClicked,
	55, 4, 131, 15, (UBYTE *)"St_artup", NULL, GD_ST_START, PLACETEXT_LEFT, NULL, (APTR)ST_STARTClicked,
	55, 23, 131, 15, (UBYTE *)"_Kill", NULL, GD_ST_KILL, PLACETEXT_LEFT, NULL, (APTR)ST_KILLClicked
};

ULONG ExecutorGTags[] = {
	(GT_Underscore), '_', (TAG_DONE),
	(GT_Underscore), '_', (TAG_DONE),
	(GT_Underscore), '_', (TAG_DONE),
	(GTST_MaxChars), 128, (GT_Underscore), '_', (TAG_DONE),
	(GTST_MaxChars), 128, (GT_Underscore), '_', (TAG_DONE)
};

static UWORD ComputeX( UWORD value )
{
	return(( UWORD )((( FontX * value ) + 3 ) / 6 ));
}

static UWORD ComputeY( UWORD value )
{
	return(( UWORD )((( FontY * value ) + 4 ) / 9 ));
}

static void ComputeFont( UWORD width, UWORD height )
{
	Forbid();
	Font = &Attr;
	Font->ta_Name = (STRPTR)GfxBase->DefaultFont->tf_Message.mn_Node.ln_Name;
	Font->ta_YSize = FontY = GfxBase->DefaultFont->tf_YSize;
	FontX = GfxBase->DefaultFont->tf_XSize;
	Permit();

	OffX = Scr->WBorLeft;
	OffY = Scr->RastPort.TxHeight + Scr->WBorTop + 1;

	if ( width && height ) {
		if (( ComputeX( width ) + OffX + Scr->WBorRight ) > Scr->Width )
			goto UseTopaz;
		if (( ComputeY( height ) + OffY + Scr->WBorBottom ) > Scr->Height )
			goto UseTopaz;
	}
	return;

UseTopaz:
	Font->ta_Name = (STRPTR)"topaz.font";
	FontX = FontY = Font->ta_YSize = 8;
}

int SetupScreen( void )
{
	if ( ! ( Scr = LockPubScreen( PubScreenName )))
		return( 1L );

	ComputeFont( 0, 0 );

	if ( ! ( VisualInfo = GetVisualInfo( Scr, TAG_DONE )))
		return( 2L );

	return( 0L );
}

void CloseDownScreen( void )
{
	if ( VisualInfo ) {
		FreeVisualInfo( VisualInfo );
		VisualInfo = NULL;
	}

	if ( Scr        ) {
		UnlockPubScreen( NULL, Scr );
		Scr = NULL;
	}
}

int HandleExecutorIDCMP( void )
{
	struct IntuiMessage	*m;
	int			(*func)();
	BOOL			running = TRUE;

	while( m = GT_GetIMsg( ExecutorWnd->UserPort )) {

		CopyMem(( char * )m, ( char * )&ExecutorMsg, (long)sizeof( struct IntuiMessage ));

		GT_ReplyIMsg( m );

		switch ( ExecutorMsg.Class ) {

			case	IDCMP_REFRESHWINDOW:
				GT_BeginRefresh( ExecutorWnd );
				GT_EndRefresh( ExecutorWnd, TRUE );
				break;

			case	IDCMP_VANILLAKEY:
				running = ExecutorVanillaKey();
				break;

			case	IDCMP_GADGETUP:
			case	IDCMP_GADGETDOWN:
				func = ( void * )(( struct Gadget * )ExecutorMsg.IAddress )->UserData;
				running = func();
				break;
		}
	}
	return( running );
}

int OpenExecutorWindow( void )
{
	struct NewGadget	ng;
	struct Gadget	*g;
	UWORD		lc, tc;
	UWORD		wleft = ExecutorLeft, wtop = ExecutorTop, ww, wh;

	ComputeFont( ExecutorWidth, ExecutorHeight );

	ww = ComputeX( ExecutorWidth );
	wh = ComputeY( ExecutorHeight );

	if (( wleft + ww + OffX + Scr->WBorRight ) > Scr->Width ) wleft = Scr->Width - ww;
	if (( wtop + wh + OffY + Scr->WBorBottom ) > Scr->Height ) wtop = Scr->Height - wh;

	if ( ! ( ExecutorFont = OpenDiskFont( Font )))
		return( 5L );

	if ( ! ( g = CreateContext( &ExecutorGList )))
		return( 1L );

	for( lc = 0, tc = 0; lc < Executor_CNT; lc++ ) {

		CopyMem((char * )&ExecutorNGad[ lc ], (char * )&ng, (long)sizeof( struct NewGadget ));

		ng.ng_VisualInfo = VisualInfo;
		ng.ng_TextAttr   = Font;
		ng.ng_LeftEdge   = OffX + ComputeX( ng.ng_LeftEdge );
		ng.ng_TopEdge    = OffY + ComputeY( ng.ng_TopEdge );
		ng.ng_Width      = ComputeX( ng.ng_Width );
		ng.ng_Height     = ComputeY( ng.ng_Height);

		ExecutorGadgets[ lc ] = g = CreateGadgetA((ULONG)ExecutorGTypes[ lc ], g, &ng, ( struct TagItem * )&ExecutorGTags[ tc ] );

		while( ExecutorGTags[ tc ] ) tc += 2;
		tc++;

		if ( NOT g )
			return( 2L );
	}

	if ( ! ( ExecutorWnd = OpenWindowTags( NULL,
				WA_Left,	wleft,
				WA_Top,		wtop,
				WA_Width,	ww + OffX + Scr->WBorRight,
				WA_Height,	wh + OffY + Scr->WBorBottom,
				WA_IDCMP,	BUTTONIDCMP|STRINGIDCMP|IDCMP_GADGETDOWN|IDCMP_MOUSEMOVE|IDCMP_VANILLAKEY|IDCMP_REFRESHWINDOW,
				WA_Flags,	WFLG_DRAGBAR|WFLG_DEPTHGADGET|WFLG_SMART_REFRESH|WFLG_ACTIVATE|WFLG_RMBTRAP,
				WA_Gadgets,	ExecutorGList,
				WA_Title,	ExecutorWdt,
				WA_ScreenTitle,	"Executor Prefs",
				WA_PubScreen,	Scr,
				TAG_DONE )))
	return( 4L );

	GT_RefreshWindow( ExecutorWnd, NULL );

	return( 0L );
}

void CloseExecutorWindow( void )
{
	if ( ExecutorWnd        ) {
		CloseWindow( ExecutorWnd );
		ExecutorWnd = NULL;
	}

	if ( ExecutorGList      ) {
		FreeGadgets( ExecutorGList );
		ExecutorGList = NULL;
	}

	if ( ExecutorFont ) {
		CloseFont( ExecutorFont );
		ExecutorFont = NULL;
	}
}

