#include <libraries/gadtools.h>

#include <clib/exec_protos.h>
#include <clib/intuition_protos.h>
#include <clib/gadtools_protos.h>

#include "/Garshnelib/Garshnelib_protos.h"
#include "/Garshnelib/Garshnelib_pragmas.h"

#include "Interference.h"
#include "Interference_rev.h"
#include "/main.h"
#include "//defs.h"

struct ModulePrefs
{
	LONG Mode;
	LONG Depth;
	LONG ExtendPal;
};

struct ModulePrefs nP;
VOID *OldPrefs = 0L;
STATIC const UBYTE VersTag[] = VERSTAG;

int BT_SAVEClicked( VOID )
{
	if( OldPrefs )
	{
		CopyMem( &nP, OldPrefs, sizeof( struct ModulePrefs ));
		SavePrefs( OldPrefs );
		OldPrefs = 0L;
	}
	
	return QUIT;
}

int BT_TESTClicked( VOID )
{
	MessageServer( BM_SENDBLANK );

	return OK;
}

int BT_SCREENClicked( VOID )
{
	ScreenModeRequest( InterferenceWnd, &nP.Mode, &nP.Depth );

	return OK;
}

int BT_CANCELClicked( VOID )
{
	OldPrefs = 0L;
	
	return QUIT;
}

int SL_EXTPALClicked( VOID )
{
	nP.ExtendPal = InterferenceMsg.Code;

	return OK;
}

#define BL_SetGadgetAttrs( Gad, Tag, Val ) GT_SetGadgetAttrs( InterferenceGadgets[Gad], InterferenceWnd, 0L, Tag, Val, TAG_END )

int InterferenceVanillaKey( VOID )
{
	switch( InterferenceMsg.Code ) {
	case 's':
		return BT_SAVEClicked();
	case 't':
		return BT_TESTClicked();
	case 'd':
		return BT_SCREENClicked();
	case 'c':
		return QUIT;
	case 'p':
		BL_SetGadgetAttrs( GD_SL_EXTPAL, GTSL_Level, Inc( nP.ExtendPal, 1, 4 ));
		return OK;
	case 'P':
		BL_SetGadgetAttrs( GD_SL_EXTPAL, GTSL_Level, Dec( nP.ExtendPal, 1, 0 ));
		return OK;
	default:
		return OK;
	}
}

VOID DoPrefs( LONG command, VOID *Prefs )
{
	switch( command )
	{
	case STARTUP:
		OldPrefs = Prefs;
		CopyMem( Prefs, &nP, sizeof( struct ModulePrefs ));
		if( !SetupScreen())
		{
			InterferenceLeft = ( Scr->Width - ComputeX( InterferenceWidth ))/2 - Scr->WBorRight;
			InterferenceTop = ( Scr->Height - ComputeY( InterferenceHeight ) - Font->ta_YSize )/2 -
				Scr->WBorBottom;
			if( !OpenInterferenceWindow())
				BL_SetGadgetAttrs( GD_SL_EXTPAL, GTSL_Level, nP.ExtendPal );
			CloseDownScreen();
		}
		break;
	case IDCMP:
		if( HandleInterferenceIDCMP() != QUIT )
			break;
	case KILL:
		CloseInterferenceWindow();
		break;
	}
}

LONG WndSignal( VOID )
{
	return InterferenceWnd ? 1L << InterferenceWnd->UserPort->mp_SigBit : 0L;
}

VOID FillDefaults( VOID *Prefs )
{
	struct ModulePrefs mPO = { 0L, 4L, 2L };

	mPO.Mode = getTopScreenMode();
	CopyMem( &mPO, Prefs, sizeof( struct ModulePrefs ));
}
