/*
 *  Source machine generated by GadToolsBox V2.0b
 *  which is (c) Copyright 1991-1993 Jaba Development
 *
 *  GUI Designed by : Michael D. Bayne
 */

#include <exec/types.h>
#include <intuition/intuition.h>
#include <intuition/classes.h>
#include <intuition/classusr.h>
#include <intuition/imageclass.h>
#include <intuition/gadgetclass.h>
#include <libraries/gadtools.h>
#include <graphics/displayinfo.h>
#include <graphics/gfxbase.h>
#include <clib/exec_protos.h>
#include <clib/intuition_protos.h>
#include <clib/gadtools_protos.h>
#include <clib/graphics_protos.h>
#include <clib/utility_protos.h>
#include <string.h>
#include <clib/diskfont_protos.h>

#include "Species.h"

struct Screen         *Scr = NULL;
UBYTE                 *PubScreenName = NULL;
APTR                   VisualInfo = NULL;
struct Window         *SpeciesWnd = NULL;
struct Gadget         *SpeciesGList = NULL;
struct IntuiMessage    SpeciesMsg;
struct Gadget         *SpeciesGadgets[5];
UWORD                  SpeciesLeft = 0;
UWORD                  SpeciesTop = 12;
UWORD                  SpeciesWidth = 227;
UWORD                  SpeciesHeight = 36;
UBYTE                 *SpeciesWdt = (UBYTE *)"Species Prefs";
struct TextAttr       *Font, Attr;
UWORD                  FontX, FontY;
UWORD                  OffX, OffY;
struct TextFont       *SpeciesFont = NULL;

UWORD SpeciesGTypes[] = {
	SLIDER_KIND,
	BUTTON_KIND,
	BUTTON_KIND,
	BUTTON_KIND,
	BUTTON_KIND
};

struct NewGadget SpeciesNGad[] = {
	47, 4, 150, 11, (UBYTE *)"S_ize", NULL, GD_SL_SIZE, PLACETEXT_LEFT, NULL, (APTR)SL_SIZEClicked,
	4, 19, 52, 14, (UBYTE *)"_Save", NULL, GD_BT_SAVE, PLACETEXT_IN, NULL, (APTR)BT_SAVEClicked,
	172, 19, 52, 14, (UBYTE *)"_Cancel", NULL, GD_BT_CANCEL, PLACETEXT_IN, NULL, (APTR)BT_CANCELClicked,
	60, 19, 52, 14, (UBYTE *)"_Test", NULL, GD_BT_TEST, PLACETEXT_IN, NULL, (APTR)BT_TESTClicked,
	116, 19, 52, 14, (UBYTE *)"_Display", NULL, GD_BT_SCREEN, PLACETEXT_IN, NULL, (APTR)BT_SCREENClicked
};

ULONG SpeciesGTags[] = {
	(GTSL_Min), 3, (GTSL_Max), 10, (GTSL_Level), 6, (GTSL_MaxLevelLen), 4, (GTSL_LevelFormat), (ULONG)"%2ld", (GTSL_LevelPlace), (PLACETEXT_RIGHT), (PGA_Freedom), LORIENT_HORIZ, (GA_RelVerify), TRUE, (GT_Underscore), '_', (TAG_DONE),
	(GT_Underscore), '_', (TAG_DONE),
	(GT_Underscore), '_', (TAG_DONE),
	(GT_Underscore), '_', (TAG_DONE),
	(GT_Underscore), '_', (TAG_DONE)
};

static UWORD ComputeX( UWORD value )
{
	return(( UWORD )((( FontX * value ) + 3 ) / 6 ));
}

static UWORD ComputeY( UWORD value )
{
	return(( UWORD )((( FontY * value ) + 4 ) / 9 ));
}

static void ComputeFont( UWORD width, UWORD height )
{
	Forbid();
	Font = &Attr;
	Font->ta_Name = (STRPTR)GfxBase->DefaultFont->tf_Message.mn_Node.ln_Name;
	Font->ta_YSize = FontY = GfxBase->DefaultFont->tf_YSize;
	FontX = GfxBase->DefaultFont->tf_XSize;
	Permit();

	OffX = Scr->WBorLeft;
	OffY = Scr->RastPort.TxHeight + Scr->WBorTop + 1;

	if ( width && height ) {
		if (( ComputeX( width ) + OffX + Scr->WBorRight ) > Scr->Width )
			goto UseTopaz;
		if (( ComputeY( height ) + OffY + Scr->WBorBottom ) > Scr->Height )
			goto UseTopaz;
	}
	return;

UseTopaz:
	Font->ta_Name = (STRPTR)"topaz.font";
	FontX = FontY = Font->ta_YSize = 8;
}

int SetupScreen( void )
{
	if ( ! ( Scr = LockPubScreen( PubScreenName )))
		return( 1L );

	ComputeFont( 0, 0 );

	if ( ! ( VisualInfo = GetVisualInfo( Scr, TAG_DONE )))
		return( 2L );

	return( 0L );
}

void CloseDownScreen( void )
{
	if ( VisualInfo ) {
		FreeVisualInfo( VisualInfo );
		VisualInfo = NULL;
	}

	if ( Scr        ) {
		UnlockPubScreen( NULL, Scr );
		Scr = NULL;
	}
}

int HandleSpeciesIDCMP( void )
{
	struct IntuiMessage	*m;
	int			(*func)();
	BOOL			running = TRUE;

	while( m = GT_GetIMsg( SpeciesWnd->UserPort )) {

		CopyMem(( char * )m, ( char * )&SpeciesMsg, (long)sizeof( struct IntuiMessage ));

		GT_ReplyIMsg( m );

		switch ( SpeciesMsg.Class ) {

			case	IDCMP_REFRESHWINDOW:
				GT_BeginRefresh( SpeciesWnd );
				GT_EndRefresh( SpeciesWnd, TRUE );
				break;

			case	IDCMP_VANILLAKEY:
				running = SpeciesVanillaKey();
				break;

			case	IDCMP_GADGETUP:
			case	IDCMP_GADGETDOWN:
				func = ( void * )(( struct Gadget * )SpeciesMsg.IAddress )->UserData;
				running = func();
				break;
		}
	}
	return( running );
}

int OpenSpeciesWindow( void )
{
	struct NewGadget	ng;
	struct Gadget	*g;
	UWORD		lc, tc;
	UWORD		wleft = SpeciesLeft, wtop = SpeciesTop, ww, wh;

	ComputeFont( SpeciesWidth, SpeciesHeight );

	ww = ComputeX( SpeciesWidth );
	wh = ComputeY( SpeciesHeight );

	if (( wleft + ww + OffX + Scr->WBorRight ) > Scr->Width ) wleft = Scr->Width - ww;
	if (( wtop + wh + OffY + Scr->WBorBottom ) > Scr->Height ) wtop = Scr->Height - wh;

	if ( ! ( SpeciesFont = OpenDiskFont( Font )))
		return( 5L );

	if ( ! ( g = CreateContext( &SpeciesGList )))
		return( 1L );

	for( lc = 0, tc = 0; lc < Species_CNT; lc++ ) {

		CopyMem((char * )&SpeciesNGad[ lc ], (char * )&ng, (long)sizeof( struct NewGadget ));

		ng.ng_VisualInfo = VisualInfo;
		ng.ng_TextAttr   = Font;
		ng.ng_LeftEdge   = OffX + ComputeX( ng.ng_LeftEdge );
		ng.ng_TopEdge    = OffY + ComputeY( ng.ng_TopEdge );
		ng.ng_Width      = ComputeX( ng.ng_Width );
		ng.ng_Height     = ComputeY( ng.ng_Height);

		SpeciesGadgets[ lc ] = g = CreateGadgetA((ULONG)SpeciesGTypes[ lc ], g, &ng, ( struct TagItem * )&SpeciesGTags[ tc ] );

		while( SpeciesGTags[ tc ] ) tc += 2;
		tc++;

		if ( NOT g )
			return( 2L );
	}

	if ( ! ( SpeciesWnd = OpenWindowTags( NULL,
				WA_Left,	wleft,
				WA_Top,		wtop,
				WA_Width,	ww + OffX + Scr->WBorRight,
				WA_Height,	wh + OffY + Scr->WBorBottom,
				WA_IDCMP,	SLIDERIDCMP|BUTTONIDCMP|IDCMP_VANILLAKEY|IDCMP_REFRESHWINDOW,
				WA_Flags,	WFLG_DRAGBAR|WFLG_DEPTHGADGET|WFLG_SMART_REFRESH|WFLG_ACTIVATE|WFLG_RMBTRAP,
				WA_Gadgets,	SpeciesGList,
				WA_Title,	SpeciesWdt,
				WA_ScreenTitle,	"Species Prefs",
				WA_PubScreen,	Scr,
				WA_AutoAdjust,	TRUE,
				WA_PubScreenFallBack,	TRUE,
				TAG_DONE )))
	return( 4L );

	GT_RefreshWindow( SpeciesWnd, NULL );

	return( 0L );
}

void CloseSpeciesWindow( void )
{
	if ( SpeciesWnd        ) {
		CloseWindow( SpeciesWnd );
		SpeciesWnd = NULL;
	}

	if ( SpeciesGList      ) {
		FreeGadgets( SpeciesGList );
		SpeciesGList = NULL;
	}

	if ( SpeciesFont ) {
		CloseFont( SpeciesFont );
		SpeciesFont = NULL;
	}
}

