/*
 *	Copyright (c) 1993 Michael D. Bayne.
 *	All rights reserved.
 *
 *	Please see the documentation accompanying the distribution for distribution
 *  and disclaimer information.
 */

#include <libraries/gadtools.h>

#include <clib/exec_protos.h>
#include <clib/intuition_protos.h>
#include <clib/gadtools_protos.h>

#include "Worms.h"
#include "Worms_rev.h"
#include "/main.h"
#include "//defs.h"

struct ModulePrefs
{
	LONG Number;
	LONG Length;
	LONG FadePct;
	LONG TopScr;
};

struct ModulePrefs nP;
VOID *OldPrefs = 0L;
STATIC const UBYTE VersTag[] = VERSTAG;

int BT_SAVEClicked( VOID )
{
	if( OldPrefs )
	{
		CopyMem( &nP, OldPrefs, sizeof( struct ModulePrefs ));
		SavePrefs( OldPrefs );
		OldPrefs = 0L;
	}
	
	return QUIT;
}

int BT_TESTClicked( VOID )
{
	MessageServer( BM_SENDBLANK );

	return OK;
}

int BT_CANCELClicked( VOID )
{
	OldPrefs = 0L;
	
	return QUIT;
}

int SL_NUMBERClicked( VOID )
{
	nP.Number = WormsMsg.Code;

	return OK;
}

int SL_LENGTHClicked( VOID )
{
	nP.Length = WormsMsg.Code;

	return OK;
}

int SL_FADEClicked( VOID )
{
	nP.FadePct = WormsMsg.Code;

	return OK;
}

int CY_TOPSCRClicked( VOID )
{
	nP.TopScr = WormsMsg.Code;

	return OK;
}

#define BL_SetGadgetAttrs( Gad, Tag, Val ) GT_SetGadgetAttrs( WormsGadgets[Gad], WormsWnd, 0L, Tag, Val, TAG_END )

int WormsVanillaKey( VOID )
{
	switch( WormsMsg.Code ) {
	case 's':
		return BT_SAVEClicked();
	case 't':
		return BT_TESTClicked();
	case 'c':
		return QUIT;
	case 'w':
		BL_SetGadgetAttrs( GD_SL_NUMBER, GTSL_Level, Inc( nP.Number, 1, 50 ));
		return OK;
	case 'W':
		BL_SetGadgetAttrs( GD_SL_NUMBER, GTSL_Level, Dec( nP.Number, 1, 1 ));
		return OK;
	case 'f':
		BL_SetGadgetAttrs( GD_SL_FADE, GTSL_Level, Inc( nP.FadePct, 1, 99 ));
		return OK;
	case 'F':
		BL_SetGadgetAttrs( GD_SL_FADE, GTSL_Level, Dec( nP.FadePct, 1, 0 ));
		return OK;
	default:
		return OK;
	}
}

VOID DoPrefs( LONG command, VOID *Prefs )
{
	switch( command )
	{
	case STARTUP:
		OldPrefs = Prefs;
		CopyMem( Prefs, &nP, sizeof( struct ModulePrefs ));
		if( !SetupScreen())
		{
			WormsLeft = ( Scr->Width - ComputeX( WormsWidth ))/2 -
				Scr->WBorRight;
			WormsTop = ( Scr->Height - ComputeY( WormsHeight ) -
						Font->ta_YSize )/2 - Scr->WBorBottom;
			if( !OpenWormsWindow())
			{
				BL_SetGadgetAttrs( GD_SL_NUMBER, GTSL_Level, nP.Number );
				BL_SetGadgetAttrs( GD_SL_LENGTH, GTSL_Level, nP.Length );
				BL_SetGadgetAttrs( GD_SL_FADE, GTSL_Level, nP.FadePct );
				BL_SetGadgetAttrs( GD_CY_TOPSCR, GTCY_Active, nP.TopScr );
			}
			CloseDownScreen();
		}
		break;
	case IDCMP:
		if( HandleWormsIDCMP() != QUIT )
			break;
	case KILL:
		CloseWormsWindow();
		break;
	}
}

LONG WndSignal( VOID )
{
	return WormsWnd ? 1L << WormsWnd->UserPort->mp_SigBit : 0L;
}

VOID FillDefaults( VOID *Prefs )
{
	struct ModulePrefs mPO = { 10L, 10L, 10L, 0L };

	CopyMem( &mPO, Prefs, sizeof( struct ModulePrefs ));
}
