

   This file describes [1mClipHistory[0m, version 2.2, a program that adds
a history to the clipboard.

Introduction
************

   This is a program that I thought about writing for a long time (a
year or so! :) before I actually implemented it. I first got the idea
when I had used the history feature of [1mPowerSnap[0m (by Nico Franois)
a little while. I soon realised that it was a very convenient feature.

   The problem is that other programs uses the clipboard as well. The
history [1mPowerSnap[0m maintains only applies to the text that
[1mPowerSnap[0m writes to the clipboard, not the ones e.g. my editor
writes. And I thought that it would indeed be useful to have them in a
history too.

   One problem with such a history is that it easily can eat up a lot
of memory, since cuts and copies in an editor can be rather large at
times. To remedy this problem, there are several filtering options,
that limits the amount of memory [1mClipHistory[0m may use. But more about
this later on in this document.

   One interesting detail: [1mClipHistory[0m is a completely system friendly
program, in that it doesn't patch any functions at all (unless you
really want it to! :). It only uses well documented features of the
operating system. This does have a minor drawback: [1mClipHistory[0m can
miss clips, if several clips are written in a very short time. But this
shouldn't be any problem, I think.. :)

Legal information
*****************

       [1mClipHistory[0m is freeware, i.e. copyrighted, freely distributable
software. Feel free to use and copy this program, as long as the
following restrictions are fulfilled:

   *  All files are copied without any alterations. If any extra files
     are added, it must be obvious that they don't belong to the
     original distribution, and that they don't need to be included in
     any redistribution.

     Exception: So called "BBS ads" may [3mnot [0mbe added.

   *  The copying is done on a non-commercial basis. A small fee to
     cover media costs etc. may be charged.

   *  The copier isn't claiming the copyright of this program.

   Any exeptions from the above requires a written permission from the
author.

No warranty
===========

   THERE IS NO WARRANTY FOR THE PROGRAMS, TO THE EXTENT PERMITTED BY
APPLICABLE LAW. EXCEPT WHEN OTHERWISE STATED IN WRITING THE COPYRIGHT
HOLDER AND/OR OTHER PARTIES PROVIDE THE PROGRAMS "AS IS" WITHOUT
WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING, BUT NOT
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
PARTICULAR PURPOSE. THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE
OF THE PROGRAMS IS WITH YOU. SHOULD THE PROGRAMS PROVE DEFECTIVE, YOU
ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION.

   IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN
WRITING WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MAY
REDISTRIBUTE THE PROGRAMS AS PERMITTED ABOVE, BE LIABLE TO YOU FOR
DAMAGES, INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL
DAMAGES ARISING OUT OF THE USE OR INABILITY TO USE THE PROGRAMS
(INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA BEING RENDERED
INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD PARTIES OR A FAILURE OF
THE PROGRAMS TO OPERATE WITH ANY OTHER PROGRAMS), EVEN IF SUCH HOLDER
OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.

System requirements
*******************

       [1mClipHistory[0m have very modest system requirements. It needs OS
2.04 or better, although OS 3.0 or better will make [1mClipHistory[0m
operate slightly better.

   If you have [1mReqTools[0m (by Nico Franois) installed, then
[1mClipHistory[0m will use [1mReqTools[0m for its requesters (you can disable
this if you like). Otherwise the "normal" system requesters will be
used.

Installation
************

       [1mClipHistory[0m is easy to install. Simply copy the program (and
its icon) to [1mWBStartup[0m, or whereever you find convenient. If you have
OS 2.1 or better, you might want to copy a catalog file as well, to make
[1mClipHistory[0m operate in another language than english.

   The easiest way is to let the [1mInstaller[0m do it (if you have it that
is!  :). If not, copy the file [1mcliphistory.catalog[0m as found in the
[1mCatalogs/<language>[0m drawer to [1mLocale:Catalogs/<language>[0m (or to the
drawer [1mCatalogs/<language>[0m in the same drawer as you placed
[1mClipHistory[0m). In either case, <language> should be one of the
languages you have select in the [1mLocale[0m preferences editor.

   If there is no catalog file for your language, please try to fill in
the file [1mEmpty.ct[0m in the [1mCatalogs[0m drawer and send it to me. I will
then include the catalog in the next release of [1mClipHistory[0m. It would
be nice if you could translate the [1mInstaller[0m script as well.

Usage
*****

   To use [1mClipHistory[0m, you first make sure that the tooltypes are set
up properly. Then start it. You can also start if from a shell, but then
you must remember to [1mRun[0m it (and to write suitable arguments). To
make it permanently installed, simply drop it into [1mWBStartup[0m, or
enter a suitable line in your [1mS:User-Startup[0m file.

       [1mClipHistory[0m installs itself as a commodity, so you can use the
Commodities [1mExchange[0m program to show the interface, disable/enable
it, or remove it completely. Starting [1mClipHistory[0m a second time (for
the same clipboard unit (option [1mCLIPUNIT[0m)) will cause the first copy
to show the interface. Pressing the hotkey will also open the interface
(option [1mCX_POPKEY[0m). See Options for more information.

   The user interface of [1mClipHistory[0m is very simple; it contains of a
window with a list gadget. This list contains all the remembered clips.
There is also a menu strip attached (see Menus).

   The text showed in the list is either the text - if it is a text
clip - or the type of the IFF clip (everything on the clipboard should
be in IFF format), followed by its size (in bytes). If you have OS 3.0
or higher, the non-text clips will be shown in bold.

   To select an item in the list, you either click once on it with the
mouse, or you use the cursur Up/Down keys (optionally with the
Shift/Alt/Ctrl qualifiers) to highlight the requested item.

   To copy an item to the clipboard, you double-click on the item, or
press Return when the proper item is selected. Unless the [1mSTICKY[0m
option (see Options) have been used, the window will close.

   Esc closes the window.

Menus
*****

   The window [1mClipHistory[0m opens have the following menus:

[1mProject[0m
    [1mAbout...[0m
          Shows some information about the program and the history.

    [1mHide[0m
          Close the window, but don't quit.

    [1mQuit[0m
          Close the window and quit.

[1mEdit[0m
    [1mOpen clipboard...[0m
          This will open a file requester, allowing you to select a
          file that will be written to the clipboard. If it is an IFF
          file, it will be copied as it is, otherwise it will be
          written as an IFF FTXT file.

    [1mSave clipboard as...[0m
          This will open a file requester, allowint you to select a
          filename to which the current clipboard contents will be
          written.

    [1mShow clipboard...[0m
          This will write the currently clipboard contents to a
          temprary file, and start the [1mSHOWCLIP[0m program to show this
          file (see Options for more information),

    [1mClear clipboard[0m
          Simply clear the clipboard, by writing a special (and small)
          IFF EMTY file to it.

[1mHistory[0m
    [1mDelete item...[0m
          This will delete the currently selected item. You can also
          press Del to do this.

    [1mDelete all items...[0m
          This will delete [3mall [0mclips in the list. You can also press
          Shift-Del to do this.

    [1mSave item as...[0m
          This allows you to save the currently selected item to a file
          of your choice.

    [1mShow item...[0m
          This will write the currently selected item to a temporary
          file, and start the [1mSHOWCLIP[0m program to show this file (see
          Options for more information),

[1mOptions[0m
    [1mCreate icons?[0m
          If checked, then icons will be created for the files you
          save. This is the same as the option [1mCREATEICONS[0m (see
          Options).

    [1mSave text as IFF?[0m
          If checked, then text clips (those that shows up as "normal"
          text in the window) will be saved as IFF files. If you save
          them as normal text, then some information might be lost
          (technical note: all CHRS chunks will be saved, but no
          other(s)). Same as the option [1mTEXTASIFF[0m (see Options).

    [1mReqTools?[0m
          If checked, then [1mReqTools[0m will be used for requesters, if
          it's available. Same as the option [1mREQTOOLS[0m (see Options).

Options
*******

   Options can be specified in the tooltypes (when starting from the
[1mWorkbench[0m) or on the command line (when starting from a [1mShell[0m).

[1mCX_PRIORITY[0m
     This value specifies the priority [1mClipHistory[0m will have in the
     commodities input chain. This priority only applies to the hotkey.
     Default is 0. Accpted range is -128 to 127.

[1mCX_POPKEY[0m
     This hotkey will open the window. Default is "control lalt c".
     Please refer to your Amiga manual for more information about
     hotkey descriptors.

[1mCX_POPUP[0m
     If this option is set to YES, then [1mClipHistory[0m will open the
     window upon startup (this is the default). Use NO to disable this.

[1mCLIPUNIT[0m
     This value specifies the clipboard unit to use. Default is 0.
     Accepted range is 0 to 255.

     You can start one copy of [1mClipHistory[0m for each clipboard unit. In
     Commodities [1mExchange[0m, the name will be "ClipHistory <unit>",
     where <unit> is the number you specify here.

         [3mNote: [0m[1mClipHistory[0m can be made resident. This is useful if
     you start several copies of [1mClipHistory[0m, so that all copies
     share the same code (which saves quite a bit of memory).

[1mTOOLPRI[0m
     This value specifies the "normal" priority for [1mClipHistory[0m. To
     make sure that [1mClipHistory[0m doesn't miss any clips, even if the
     computer is doing much work, you might want to rise the task
     priority of [1mClipHistory[0m. Default is to use whatever priority
     [1mClipHistory[0m was started in (this is normally 0). Accepted range is
     -128 to 4.

         [3mNote: [0mThe [1mWorkbench[0m also supports the [1mTOOLPRI[0m tooltype.
     It was added to [1mClipHistory[0m so that [1mShell[0m users easily can
     change the priority as well.

[1mWORKPRI[0m
     Some operations [1mClipHistory[0m does can take a little time. Here you
     can specify the priority [1mClipHistory[0m should use during this
     time, so that other programs can run normally. Usually a negative
     value should be entered. The default is not to change the
     priority. Accepted range is -128 to 4.

[1mSILENT[0m
     If this option is set to YES, then [1mClipHistory[0m won't display any
     requesters or flash the screen for various clip operation errors,
     like when there was a problem reading/writing to the clipboard, or
     when there wasn't enough memory to save a clip. Default is NO.

[1mPORTNAME[0m
     This string lets you specify the name of the [1mARexx[0m port
     [1mClipHistory[0m opens. The default is "CLIPHISTORYx", where "x" is
     the clipboard unit the history operates on (see [1mCLIPUNIT[0m). If
     you enter an empty string (""), then no [1mARexx[0m port will be
     opened. If [1mARexx[0m isn't installed, then no [1mARexx[0m port will be
     opened either.

[1mNEXTKEY[0m
     This hotkey will activate the next item in the history (if
     possible) and paste that one to the clipboard without opening the
     window. Useful when you have snapped a few strings and want to
     paste them somewere. This works even if the window should happen
     to be open. Default is no hotkey ("").

[1mPREVKEY[0m
     This hotkey works much like [1mNEXTKEY[0m, but it will paste the
     previous history item (if possible) instead. Default is no hotkey
     ("").

[1mAUTOSELECT[0m
     By default, [1mNEXTKEY[0m and [1mPREVKEY[0m will fail (flashing the display
     to inform you about it) if no clip item is selected. If this
     option is set to YES, then [1mNEXTKEY[0m will automatically select the
     first item in the list, and [1mPREVKEY[0m will select the last item.

[1mPUBSCREEN[0m
     This string specifies the public screen on which [1mClipHistory[0m
     should open its window on. Default is the frontmost screen if it
     is public (if [1mOPENONALL[0m is on, it will use the frontmost screen
     anyway), or the default public screen.

[1mOPENONALL[0m
     If this option is set to YES, then [1mClipHistory[0m will open on the
     frontmost screen, regardless if it is public or not. Default is NO.

         [3mNote: [0mIn order for this to work properly, a function in
     [1mIntuition[0m ([1mCloseScreen()[0m) needs to be patched (this patch is
     only installed if this option have been activated). If some other
     program have patched the same program and you try to exit, then
     [1mClipHistory[0m will exit anyway, but it will leave a small memory
     allocation, to make sure there aren't any problems. If you have a
     [1mSetMan[0m-like program installed, this should never happen.

[1mFONTNAME[0m
     This string specifies the name of the font (including the ".font"
     extension) to use for the window/menus. If not specified, then the
     current screen font is used. You must specify both [1mFONTNAME[0m and
     [1mFONTSIZE[0m.

     Hint: If you have [1mMagicWB[0m, it can be a good idea to use e.g.
     XHelvetica, since that font is "complete", i.e. chars than
     normally aren't printable holds graphics to identify the char in
     question.

[1mFONTSIZE[0m
     This value specifies the size of the above font. You must specify
     both [1mFONTNAME[0m and [1mFONTSIZE[0m.

[1mWINDOWLEFT[0m
     Initial left edge of the window. Default is to center the window
     on the screen.

[1mWINDOWTOP[0m
     Initial top edge of the window. Default is to center the window on
     the screen.

[1mWINWIDTH[0m
     Initial width of the window. Default is <width of the screen>/2.

[1mWINHEIGHT[0m
     Initial height of the window. Default is <height of the screen>/3.

[1mSTICKY[0m
     If this option is set to YES, then [1mClipHistory[0m won't close the
     window after writing a clip to the clipboard. Default is NO.

[1mSINGLECLICK[0m
     If this option is set to YES, then a single click with the mouse
     on an item is enough to paste it to the clipboard. Click with
     Shift, Alt or Ctrl pressed to select an item without pasting (a
     doubleclick with any qualifier down will also paste). If set to
     NO, a doubleclick is needed to paste the item. A single click with
     any qualifier down will then paste the item. Default is NO.

[1mPOPSCREEN[0m
     If this option is set to YES, then [1mClipHistory[0m will - when
     closing its window - restore the screen that was in front before
     the window was opened.  This only needs to be done if that screen
     wasn't public. Default is NO.

         [3mNote: [0mUsing [1mPUBSCREEN[0m, [1mOPENONALL[0m or [1mSTICKY[0m will
     disable this option.

[1mSAVEPOS[0m
     If this option is set to YES, then [1mClipHistory[0m will remember the
     current position of the window when you close it. Otherwise it
     will reopen using the position specified in the arguments (or the
     defaults). Default is NO.

[1mSAVESIZE[0m
     If this option is set to YES, then [1mClipHistory[0m will remember the
     current size of the window when you close it. Otherwise it will
     reopen using the size specified in the arguments (or the
     defaults). Default is NO.

[1mMAXCLIPS[0m
     This value specifies the maximum number of clips that the history
     can hold.  Any value accpted. Note that 0 really means 1...
     Default is 32767 (the listview handling routines in the OS can't
     cope with more, so.. :).

[1mMAXCLIPSIZE[0m
     If the clip is larger than this value, then it will not be saved
     in the history. Using 0 here will disable the history. Default is
     the [1mMAXMEM[0m limit (see below) if that one is specified. Otherwise
     there is no limit (other than the amount of free memory).

[1mMINCLIPSIZE[0m
     If the clip is smaller than this value, then it will not be saved
     in the history. The default is 0.

     Please note that this refers to the total size of the clip,
     including the extra overhead due to the IFF file format. For a
     minimal IFF file (as saved by e.g. [1mPowerSnap[0m), this overhead is
     20 bytes. Also, an IFF file is (read: should be) always padded to
     an even number of bytes.  Thus, a relatively useful minimum could
     be 22, which would force each saved clip to have at least 3 data
     bytes (when talking about saved text at least).

[1mMAXMEM[0m
     This value specifies how much memory the history may use at most.
     The history is dynamically allocated, using so called memory pools
     (to reduce memory fragmentation). Thus, the actual amount of
     memory used might be a little more than this value. Default is no
     max (other than the amount of free memory).

[1mMATCH[0m
     If this option is set to YES, check all new items against the last
     one, and only save the new one if it is different. Default is NO.

[1mFULLMATCH[0m
     Like [1mMATCH[0m, but check [3mall [0mentries instead. This option
     overrides [1mMATCH[0m Default is NO.

         [3mWarning: [0mThis can take some time if you have a large history
     ([1mClipHistory[0m will use the [1mWORKPRI[0m (see above) during this
     check). If more than one clip is written to the clipboard during
     this time, only the last one will be remembered.

[1mCASE[0m
     If this option is set to NO, then [1mClipHistory[0m will ignore the
     case when comparing two clips (when either [1mMATCH[0m or
     [1mFULLMATCH[0m have been used). Obviously, this is only possible when
     the clip contains text (FTXT). Default is YES.

[1mFILTER[0m
     Here you can specify which IFF types that should be saved (or not
     saved, if [1mREJECT[0m have been specified). Space separate the items.
     Case [3mis [0mimportant. There are many different IFF types available,
     and I can't mention them all, but here is a list over the most
     common ones:

    [1mFTXT[0m
          Text. ConClip and PowerSnap saves these ones.

    [1mILBM[0m
          Graphics/palettes. Saved by e.g. IconEdit.

    [1m8SVX[0m
          Sound (samples).

[1mREJECT[0m
     If this option is set to YES, them the [1mFILTER[0m (see above) will
     reject on a match instead of accept, i.e. it reverses the action
     of the filter.  Default is NO.

[1mSHOWCLIP[0m
     This option lets you specify the program to use to view a clip.
     [1mClipHistory[0m will write the currently selected clip (or the
     contents of the clipboard) to a temporary file, and then start
     this program with the filename as the first argument. Note that
     this file will not be deleted by [1mClipHistory[0m (you can do this
     with a script if you want to). Default is "MultiView".

[1mTEMPDIR[0m
     This option specifies were [1mClipHistory[0m should write the temprary
     files that the [1mSHOWCLIP[0m program should read and display. Default
     is "T:".

[1mFILETYPE[0m
     If this option is specified, then the file type will be the second
     argument to the [1mSHOWCLIP[0m program. This way, a simple [1mShell[0m
     script can be used to view the file (see the included
     [1mShowClip[0m script). This argument will be "text" if the clip was
     written as a simple text file ([1mTEXTASIFF[0m is set to NO),
     otherwise the IFF file type will be the second argumet (see
     [1mFILTER[0m for more information about IFF types).  Default is NO.

[1mSAVEPATH[0m
     This option lets you specify the directory in which the "Save
     clipboard..."/"Save item..." file requester should open the first
     time (it remembers the last used directory). The default is to
     open in the current directory for [1mClipHistory[0m

[1mTEXTASIFF[0m
     If this option is set to YES then FTXT clips will be saved as an
     IFF file, rather than a normal ASCII-file. All clips that shows up
     as "normal" text in the window are FTXT clips. Note that some
     information may be lost if a clip is saved as ASCII (e.g. font
     information). Default is NO.

[1mCREATEICONS[0m
     If this option is set to YES, then an icon will be created for
     each clip that is saved. Default is NO.

[1mREQTOOLS[0m
     If this option is set to YES, then [1mClipHistory[0m will use
     [1mReqTools[0m for requesters, if it should be available. Default is
     YES.

ARexx
*****

   As of version 2.0, [1mClipHistory[0m have an [1mARexx[0m port. This means
you can access the history and the clipboard from your [1mARexx[0m
programs. The port is called "CLIPHISTORYx" by default (where x is the
clipboard unit, specified with the [1mCLIPUNIT[0m argument), but you may
change this by using the [1mPORTNAME[0m argument. See Options for more
information.

Details
=======

   The [1mARexx[0m commands in [1mClipHistory[0m are documented in this manner:

     GetPrefs PREFS/A => VALUE/N

   This line is then followed by an exaplanation of what the command
does.  First on the line is the name of the command (in this example:
[1mGetPrefs[0m). Case is not importand when looking for a command. After
that follows the arguments (in some cases, there are no arguments). The
[1m=>[0m arrow indicates that what follows after it is the return value(s)
(a command may return several pieces of information). If no [1m=>[0m arrow
is present, then the command returns no information.

   The arguments use the standard [1mAmigaDOS[0m template. Thus, the keyword
is optional, but must be specified if the argument doesn't come in the
specified order. The keyword is the text before the [1m/[0m char, and the
character after is a modifier, that tells you a little about this
argument.  The following modifiers are used in this document (there are
others, but they are not used here):

[1m/A[0m
     This argument is required. An error is returned if the argument
     isn't specified.

[1m/N[0m
     This argument is numeric. It should be a valid decimal number, or
     an error is returned.

[1m/S[0m
     This argument is a switch. The precense of this keyword enables a
     flag. If it is not present, the flag is not enabled.

[1m/F[0m
     All text following the keyword is taken as the argument, without
     any modifications.

[1m/M[0m
     Any number of arguments may be specified here.

   These modifiers may be combined, so e.g. [1m/A/N[0m means that a numeric
value must be specified. If no modifier is present, then there are no
special requirements upon the arguments (at least not anything the
argument parser ([1mReadArgs()[0m) can check).

   These modifiers also applies to the return values. But first we need
some more information about the returns. The normal way of returning
information to an [1mARexx[0m script is to place it in [3mRC [0m(limited to
numeric results, since this also returns errors from the command) or
[3mRESULT [0m(which may contain anything). In [1mClipHistory[0m (and several other
programs) there is a little more control. Each command that returns
some information also have the two "hidden" (i.e. not documented)
arguments; [1mVAR[0m and [1mSTEM[0m. These arguments specify were the return
value should be placed.

   The [1mVAR[0m argument specifies in which variable the result should be
placed. This is baiscally the same as to return the value in
[3mRESULT.[0m

   The [1mSTEM[0m argument is a little different, and is mostly useful for
commands that returns several pieces of information. The argument
specifies the "stem base name" for the return values. Thus, if a
command have the "return template" [1mSIZE/N,ITEMS/N[0m, and we specified
the stem base name [1mTEST.[0m, then the variables (stems) [3mTEST.SIZE [0mand
[3mTEST.ITEMS [0mwould hold the returns (numeric values). If the return is
in a normal variable, then the different returns will be placed after
each other, separated by spaces.

   Now, there is a special return, which use the [1m/M[0m modifier. If we
use the same stem base name as above, and the command have the return
template [1mCLIP/M[0m, then the stem [3mTEST.CLIP.COUNT [0mwill hold the number
of strings that are returned, and [3mTEST.CLIP.0, [0m[3mTEST.CLIP.1...[0m
(until [3mTEST.CLIP.x, [0m where [1mx[0m equals [3mTEST.CLIP.COUNT [0m- 1) will
hold the different strings. If the same information is returned in a
normal variable, then there will first be the count, followed by the
different strings, separated by spaces.

   If an argument contains spaces, then it usually needs to be "double
quoted", like this:

     '"This is a quoted string"'

This is needed since [1mARexx[0m first removes the single quotes ([1m'[0m) when
it parses the string. [1mClipHistory[0m also needs quotes, to be able to
separate the arguments (these quotes must use the [1m"[0m char).

   Negative values needs to be quoted (e.g. [1m'-1'[0m). This is also true
for strings (e.g. file names) that contain a [1m:[0m char.

   If an error occured, the variable [3mRC2 [0mwill usually hold an error
message or a number (a dos error code. You can use [1mFault[0m to get an
explanation for a certain number). Note that "OPTIONS RESULTS" must
have be used in the script for this to happen.

   All commands sets [3mRC [0mto 10 for an error, 5 for a warning (e.g.
asking for a clip item that doesn't exist, or trying to do a window
operation when the window isn't open), and 0 for all ok.

   The [1mARexx[0m interface in [1mClipHistory[0m was originally developed
using [1mARexxBox[0m. The generated code was then modified in several ways
to get it smaller (without loosing any functionality).

General commands
================

[1mAbout[0m
     Simply open the about window. It will open on the same screen as
     the main window, or on the default public screen.

[1mCxActivate[0m
     Activate the [1mCommodities[0m interface. Similar to the "Active"
     gadget in the [1mExchange[0m program. Returns 5 if the interface
     already was active.

[1mCxInactivate[0m
     Similar to [1mCxActivate[0m, but inactivate the interface instead.

[1mGetPrefs PREFS/A => VALUE/N[0m
     Get the state of the specified preferences item. Currently, the
     following items may be specified:

    [1mICONS[0m
          The "Create icons?" menu item ([1mCREATEICONS[0m argument).

    [1mREQTOOLS[0m
          The "ReqTools?" menu item ([1mREQTOOLS[0m argument).

    [1mTEXTASIFF[0m
          The "Text as IFF?" menu item ([1mTEXTAIFF[0m argument).

     Currently, the value is set to 1 if the flag is set, or 0 if the
     flag isn't set.

[1mLockGUI[0m
     Lock the GUI, so that no input can be made (output can still me
     made).  These calls nest, so remember to match them properly.

[1mQuit[0m
     Quit [1mClipHistory[0m. No confirmation requester will be shown.

[1mShow PUBSCREEN[0m
     Open the GUI. If a [1mPUBSCREEN[0m argument is specified, then
     [1mClipHistory[0m will try to open on the specified public screen.

[1mUnlockGUI[0m
     Decrease the nesting count for the GUI lock. If we reach zero,
     unlock the GUI, re-enabling user input.

[1mSetPrefs PREFS/A,VALUE/A/N[0m
     Set the state of the specified preferences item. Currently, the
     following items may be specified:

    [1mICONS[0m
          The "Create icons?" menu item ([1mCREATEICONS[0m argument).

    [1mREQTOOLS[0m
          The "ReqTools?" menu item ([1mREQTOOLS[0m argument).

    [1mTEXTASIFF[0m
          The "Text as IFF?" menu item ([1mTEXTAIFF[0m argument).

     If the value is 1, then the flag is set, or if it is 0, the flag
     is cleared.

History commands
================

[1mDeleteAllItems FORCE/S[0m
     Delete all items in the history. Use [1mFORCE[0m to disable the
     confirmation requester. Returns 5 if the user cancelled the delete.

[1mDeleteItem ITEM/N,FORCE/S[0m
     Delete the specified item, or the currently selected if none was
     specified.  Use [1mFORCE[0m to disable the confirmation requester.
     Returns 5 if the user cancelled the requester, or the specified
     item didn't exist.

[1mGetTextItem ITEM/N => CLIP/M[0m
     Return the contents of the specified item, of if not specified, the
     currently selected item. If the clip doesn't contain any text,
     return 5 in [3mRC[0m. The [1mCLIP[0m array will hold the different CHRS
     chunks.  Usually, there is only one.

[1mGetSelected => ITEM/N[0m
     Returns the currently selected item, or -1 if no item is selected.

[1mItemInfo ITEM/N => TYPE,SIZE/N,NUMCHRS/N[0m
     Return some information about the specified item, or the currently
     selected item if no argument is given. The follwing information is
     returned:

    [1mTYPE[0m
          The type of the IFF file, usually FTXT, ILBM or 8SVX.

    [1mSIZE/N[0m
          The size of the clip, in bytes.

    [1mNUMCHRS/N[0m
          The number of so called CHRS chunks in the clip. If 0, then
          the clip doesn't contain any text.

[1mHistoryInfo => ITEMS/N,SIZE/N[0m
     Returns the following information about the history:

    [1mITEMS/N[0m
          Number of items currently in the history

    [1mSIZE/N[0m
          The total size of the history, in bytes.

[1mLockHistory[0m
     Lock the history, so that no items can be added to it. These calls
     nest, so remember to match them properly.

[1mPutItem ITEM/N[0m
     Write the specified or currently selected item to the clipboard.

[1mSaveItemAs NAME,ITEM/N,REQUEST/S[0m
     Save the specified or currently selected item to the specified
     file. If no file name is specified, or the [1mREQUEST[0m flag is used,
     show a requester to let the user specify the name.

[1mSelectItem ITEM/N,RELATIVE/S[0m
     Select the specified item. If the [1mRELATIVE[0m flag is used, add the
     [1mITEM[0m to the currently selected item number (there must be a
     selected item for this to work).

[1mShowItem ITEM/N[0m
     Show the specified, or currently selected item. See [1mSHOWCLIP[0m in
     the Options chapter for more information about this.

[1mUnlockHistory[0m
     Decrease the nesting count for the history lock. If we reach zero,
     unlock the history, re-enabling new items to be added.

Clipboard commands
==================

[1mClearClipboard[0m
     Clear the clipboard, by writing a special "empty" IFF-file to it.

[1mGetTextClip => CLIP/M[0m
     Return the contents of the clipboard. If the clipboard doesn't
     contain any text, return 5 in [3mRC[0m. The [1mCLIP[0m array will hold the
     CHRS chunks. Usually, there will only be one.

[1mPutFile NAME,REQUEST/S[0m
     Place the named file on the clipboard. If no name is given, or the
     [1mREQUEST[0m flag is set, open a requester for the user to select a
     file.  If the file is an IFF file, it will be copied to the
     clipboard.  Otherwise, [1mClipHistory[0m assumes the file contains
     text, and will write it as an IFF FTXT file.

[1mPutText TEXT/A/F[0m
     Put the specified text on the clipboard, as an IFF FTXT file.

[1mSaveClipAs NAME,ITEM/N,REQUEST/S[0m
     Save the clipboard contents to the specified file. If no file name
     is specified, or the [1mREQUEST[0m flag is used, show a requester to let
     the user specify the name.

[1mShowClip[0m
     Show the file in the clipboard. See the [1mSHOWCLIP[0m argument in the
     Options chapter for more information about this.

Requester commands
==================

[1mRequestFile TITLE,PATH,FILE,PATTERN => FILE[0m
     Show a file requester, with the specified title, default path and
     file, and the specified pattern, and return the selected name
     ([1mFILE[0m). If the requester is cancelled, return 5 in [3mRC[0m.

[1mRequestNotify PROMPT/A[0m
     Show the specified prompt in a requester with a single " Ok "
     gadget.

[1mRequestResponse TITLE,PROMPT/A,GADGETS[0m
     Show the specified prompt, with the specified title in a requester
     with an " Ok " and a "Cancel" gadget. Returns 0 if cancel was
     selected, or 5 if ok was selected.

     The [1mGADGETS[0m option allows you to specify your own gadgets. The
     diffenret gadgets should be separated by "|" chars. Returns 0 for
     the rightmost gadget, 1 for the leftmost, 2 for the next, and so
     on...

Window commands
===============

[1mActivateWindow[0m
     Activates the main window.

[1mChangeWindow LEFTEDGE/N,TOPEDGE/N,WIDTH/N,HEIGHT/N[0m
     Move and resize the window to the given coordinates, or as close as
     possible. '-1' for a given coordinate means "don't change this
     one".

[1mHide[0m
     Simply close the window.

[1mIsOpen => OPEN/N[0m
     Returns 1 if the window is open, or 0 if it isn't.

[1mMoveWindow LEFTEDGE/N,TOPEDGE/N[0m
     Similar to [1mChangeWindow[0m, but this command only lets you change
     the position of the window.

[1mSizeWindow WIDTH/N,HEIGHT/N[0m
     Similar to [1mChangeWindow[0m, but this command only lets you change
     the size of the window.

[1mUnZoomWindow[0m
     If the window is zoomed, then unzoom it (possibly making it
     larger).

[1mWindowToBack[0m
     Simply move the window behind any other window(s), if possible.

[1mWindowToFront[0m
     Simply move the window in front of any other window(s), if
     possible.

[1mZoomWindow[0m
     If the window isn't zoomed, then zoom it (possibly making it
     smaller).

Future
******

   There are a few things I might add to [1mClipHistory[0m:

   *  More IFF parsing. Now it is minimal, only reading/writing exactly
     what is on the clipboard, with a minor "support" for FTXT.
     Enhanced parsing could e.g. reduce the overhead for FTXT clips, by
     only saving the actual text.

   *  Separate accept and reject filters. I would need to alter the way
     they are specified though (now I'm using [1mReadArgs()[0m "[1m/M[0m"
     specifier for this, and [1mReadArgs()[0m don't like several "[1m/M[0m"
     specifiers in one template.. :).

   *  Load/save of the entire history. I don't see much use for this
     feature (and I've heard that there are very few programs that are
     able to process such a file! :)

   *  Prefs window, to edit/save the settings. Perhaps as a separate
     prefs program.

   *  Some other way of "highlighting" non-text clips on OS 3.0 or
     better. The problem is that I don't know how I should change it.
     :) Please tell me if you have any idea.

   *  Make a version using [1mTriton[0m (or some other layout engine).

   None of these things are important for me, but feel free to send me
a note telling me what *you* would like to see added (see Author
contact).

Author contact
**************

   Feel free to send comments, bug reports (detailed ones, please),
translations, money or whatever, to:

     S-mail:  Magnus Holmgren
              Kvarnbergsvgen 5
              S-444 47  Stenungsund
              SWEDEN
     
     E-mail:  cmh@augs.se (internet) or 2:204/404.6 (fidonet).

   (Note: The old S-mail (S=Snail :) address should not be used,
although mail sent to that address should reach me (but not after
August 1995))

Acknowledgements
****************

   Thanks go to the following persons, for helping me in some way with
this program:

[1mNico Franois[0m
     His program [1mPowerSnap[0m inspired me do write this program in the
     first place. He also sent me a few small (but useful) functions,
     and came with a few suggestions/bug reports.

[1mNikolai Waldman[0m
     Suggestions.

[1mMichael Berg[0m
     Bug report and suggestions.

[1mLars Eilebrecht[0m
     German translation.

[1mGeorges Concalves[0m
     French translation and [1mMagicWB[0m icon.

[1mKenneth Fribert[0m
     Danish translation.

[1mMichael Balzer[0m
     For [1mARexxBox[0m, which was used as a base for the [1mARexx[0m interface
     (the code have been modified a "little".. Saved ~5 Kb from the
     program! :).

[1mOlaf Barthel[0m
     For the "menu glyph" code from [1mterm[0m.

Program history
***************

[1mVersion 1.0:[0m
     Initial release.

[1mVersion 1.1:[0m
        *  Removed some debugging code.

        *  Added the [1mSINGLECLICK[0m flag. If YES, a single click on an
          item is enough to paste it to the clipboard. Use
          shift/alt/ctrl to select an item without pasting (a
          doubleclick with any qualifier down will also paste). If set
          to NO, a single click with any qualifier down will also paste
          the item.

        *  Recompiled with DICE 3.0.

        *  German catalog added. Unfortunately I don't have the source
          for it.. :)

[1mVersion 2.0:[0m
        *  [1mARexx[0m-port with over 40 commands added.

        *  [1mClipHistory[0m is now residentable! It wasn't that easy... :)
          (try yourself with DICE, a couple of callback hooks and a
          patch! :)

        *  French catalog and installer script by Georges Goncalves
          included.

        *  Danish catalog by Kenneth Fribert included.

        *  German catalog source included.

        *  [1mMagicWB[0m icon by Georges Concalves included.

        *  Added menu items to load/save/view/clear the current
          clipboard contents.  You can also view an item in the history.

        *  Any font specified in the tooltypes needed to be in memory
          for [1mClipHistory[0m to find it. Now it will try to load it from
          disk if possible.

        *  If the screenfont or the font specified in the tooltypes
          didn't open, [1mClipHistory[0m will now use the system default
          font instead (rather than topaz/8).

        *  Added the following arguments: [1mPORTNAME[0m, [1mNEXTKEY[0m,
          [1mPREVKEY[0m, [1mAUTOSELECT[0m, [1mSHOWCLIP[0m, [1mTEMPDIR[0m, [1mFILETYPE[0m,
          and [1mSAVEPATH[0m. See Options.

        *  [1mClipHistory[0m will now always exit even if someone have
          overpatched the function [1mClipHistory[0m may patch. If the
          patch was overpatched, there will be a small memory loss.

        *  When doing a full check, and a match is found, then
          [1mClipHistory[0m will select the item that matched, so that the
          selected item reflects the current clipboard contents. In
          general, [1mClipHistory[0m will do its best to keep the selected
          item up to date. This includes deselecting any item if no item
          in the history matches the current clipboard contents (e.g. a
          paste was filtered out)

        *  [1mClipHistory[0m will now use the OS 3.0 wait pointer when
          needed.

        *  [1mSysIHack[0m "support" added (i.e. it handles
          larger-than-normal window size gadgets properly).

        *  The window will now backfill with the current background
          color, rather than color 0.

        *  The "Settings/Create icons" menu item was not working, in
          that icons never got created. I had written a function to do
          it, but it wasn't used anywere! :)

        *  Non-FTXT clips are now shown in real bold (if possible).

        *  When deleting a single item, a new item will be selected, if
          possible.

[1mVersion 2.1:[0m
        *  The selected item wasn't always visible when the window
          opened.

        *  Removed [1mEnforcer[0m hits when data was written to the
          clipboard and the window wasn't open.

[1mVersion 2.2:[0m
        *  When copying a non-text clip from the clipboard to a file,
          then [1mClipHistory[0m would read innocent memory, and generate
          an incorrect (and often a very large) file.

        *  More tweeking of the [1mARexx[0m code. Made it somewhat smaller,
          and changed some other code to be more tolerant (e.g., stem
          base names no longer require a '.' char at the end. If not
          present, it will be added).

        *  Made a few minor fixes to the example [1mARexx[0m-script.

        *  Added scaled menu glyphs (OS 3.0+ only), based on source
          code from [1mterm[0m.

        *  Date in About requester localized. :)

        *  The [1mReqTools[0m file requester didn't open in the right
          drawer.

